"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../utils");
function setWindowSize(width, height) {
    const minWindowSize = 0;
    const maxWindowSize = 2147483647;
    if (typeof width !== 'number' || typeof height !== 'number') {
        throw new Error('setWindowSize expects width and height of type number');
    }
    if ((width < minWindowSize || width > maxWindowSize) || (height < minWindowSize || height > maxWindowSize)) {
        throw new Error('setWindowSize expects width and height to be a number in the 0 to 2^31 − 1 range');
    }
    const browser = utils_1.getBrowserObject(this);
    if (!browser.isW3C) {
        return browser._setWindowSize(width, height);
    }
    return browser.setWindowRect(null, null, width, height);
}
exports.default = setWindowSize;
